
<?php
require_once '../lib/util/HttpClient.php';
require_once '../lib/SendCloud.php';
require_once '../lib/util/Mail.php';
require_once '../lib/util/Mimetypes.php';
use PHPUnit\Framework\TestCase;
class SendMail extends TestCase
{
    function test_sendCommonMail(){
        $sendcloud=new SendCloud("***", "***");
        $mail=new Mail();
        //$mail->addBcc("lianzimi@ifaxin.com");
        //$mail->addCc("bida@ifaxin.com");
        $mail->setFrom("test@test.com");
        $mail->addTo("ben@ifaxin.com");
        //$mail->setReplyTo("reply@test.com");
        //$mail->setFromName("来自测试发送");
        $mail->setContent("这是一封测试邮件");
        $mail->setSubject("测试");
        $mail->setLabel("任务a");
        $mail->setRespEmailId(true);
        //添加多个邮件头
        //$mail->addHeader("SC-Custom-header1", "header1");
        //$mail->addHeader("SC-Custom-header2", "header2");
        $sendcloud->sendCommon($mail);
    }

    function test_sendCommonMailWithAddress(){
        $sendcloud=new SendCloud("", "");
        $mail=new Mail();
        $mail->setFrom("test@test.com");
        $mail->addTo("ben@ifaxin.com");
        $mail->setReplyTo("reply@test.com");
        $mail->setFromName("来自测试发送");
        $mail->setSubject("测试");
        $mail->setContent("这是一封测试邮件");
        $mail->setRespEmailId(true);
        $mail->setUseMaillist(true);
        //$mail->setLabel("lableId");
        //添加多个邮件头
        $mail->addHeader("SC-Custom-header1", "header1");
        $mail->addHeader("SC-Custom-header2", "header2");
        $sendcloud->sendCommon($mail);
    }

    /**
     * 当$mail->setUseMaillist(true); 设置时候$mail->addTo 指的是 地址列表
     * 当$mail->setUseMaillist(false);设置时候$mail->setXsmtpApi 中的to指的是收件人地址，此时$mail->addTo 失效
     */
    function test_sendTemplateMail(){
        $sendcloud=new SendCloud("", "");
        $mail=new Mail();
        $mail->setFrom("test@test.com");
        $mail->setXsmtpApi(json_encode(array(
                'to'=>array('123@qq.com','456@qq.com'),
                'sub'=>array(
                        '%money%'=>array('123', '456'),'%user%'=>array('123', '456')
                )
        )));
        $mail->setSubject("测试，通过模板发送");
        $mail->setRespEmailId(true);
        $templateContent=new TemplateContent();
        $templateContent->setTemplateInvokeName("pathExchange");
        $mail->setTemplateContent($templateContent);
        $sendcloud->sendTemplate($mail);

    }

    function test_sendTemplateMailWithAddress(){
        $sendcloud=new SendCloud("", "");
        $mail=new Mail();
        $mail->setFrom("test@test.com");
        $mail->addTo("test@maillist.sendcloud.org");
        $mail->setSubject("测试通过地址列表模板发送");
        $mail->setRespEmailId(true);
        $mail->setUseMaillist(true);
        $templateContent=new TemplateContent();
        $templateContent->setTemplateInvokeName("pathExchange");
        $mail->setTemplateContent($templateContent);
        $sendcloud->sendTemplate($mail);
    }

    function test_sendTemplateMailWithAddressAndAttachment(){
        $sendcloud=new SendCloud("", "");
        $mail=new Mail();
        $mail->setFrom("test@test.com");
        $mail->addTo("test@maillist.sendcloud.org");
        $mail->setSubject("测试带附件发送");
        $mail->setRespEmailId(true);
        $mail->setUseMaillist(true);
        $templateContent=new TemplateContent();
        $templateContent->setTemplateInvokeName("pathExchange");
        $mail->setTemplateContent($templateContent);

        $file1 = "/Users/sendcloud/Desktop/temp/test.pdf"; #你的附件路径
        $handle1 = fopen($file1,'rb');
        $content1 = fread($handle1,filesize($file1));
        $filetype1= Mimetypes::getInstance()->fromFilename($file1);

        $file2 = "/Users/sendcloud/Desktop/temp/test.txt";
        $handle2 = fopen($file2,'rb');
        $content2 = fread($handle2,filesize($file2));
        $filetype2= Mimetypes::getInstance()->fromFilename($file2);

        $file3 = "/Users/sendcloud/Desktop/temp/test.png";
        $handle3 = fopen($file3,'rb');
        $content3 = fread($handle3,filesize($file3));
        $filetype3= Mimetypes::getInstance()->fromFilename($file3);


        $attachment1=new Attachment();
        $attachment1->setType($filetype1);
        $attachment1->setContent($content1);
        $attachment1->setFilename("yi.png");

        $attachment2=new Attachment();
        $attachment2->setType($filetype2);
        $attachment2->setContent($content2);
        $attachment2->setFilename("er.png");

        $attachment3=new Attachment();
        $attachment3->setType($filetype3);
        $attachment3->setContent($content3);
        $attachment3->setFilename("san.png");

        $mail->addAttachment($attachment1);
        $mail->addAttachment($attachment2);
        $mail->addAttachment($attachment3);


        fclose($handle1);
        fclose($handle2);
        fclose($handle3);

        $sendcloud->sendTemplate($mail);

    }

}

//普通发送
//sendCommonMail();
//普通发送带地址邮件
//sendCommonMailWithAddress();
//模板带变量发送
//sendTemplateMail();
//模板带地址列表
//sendTemplateMailWithAddress();
//模板带地址列表，带附件
//sendTemplateMailWithAddressAndAttachment();

 
 
 

 
 

